using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace ModelEx3
{
    public partial class ModelEx : Form
    {
        public ModelEx()
        {
            InitializeComponent();
            splitContainer1.SplitterMoved += new SplitterEventHandler(splitContainer1_SplitterMoved);
            splitContainer2.SplitterMoved += new SplitterEventHandler(splitContainer2_SplitterMoved);
            modelExView1.TextOutputControl = textBox1;
            modelExView1.Initialize();
        }

        #region Panels

        void splitContainer2_SplitterMoved(object sender, SplitterEventArgs e)
        {
        }

        void splitContainer1_SplitterMoved(object sender, SplitterEventArgs e)
        {
        }

        private void fileView1_ItemActivate(object sender, EventArgs e)
        {
            //modelExView1.PauseRendering = true;
            //OpenFileDialog OpenDlg = new OpenFileDialog();
            //OpenDlg.CheckFileExists = true;
            //OpenDlg.CheckPathExists = true;
            //OpenDlg.Filter =    "Bitmap (*.bmp)|*.bmp|" +
            //                    "PNG (*.png)|*.png|" +
            //                    "JPEG (*.jpg)|*.jpg|" +
            //                    "All Files (*.*)|*.*";
            //OpenDlg.DefaultExt = "png";
            //OpenDlg.FilterIndex = 2;
            //OpenDlg.FileName = fileView1.SelectedItems[0].Text;
            //if (OpenDlg.ShowDialog() == DialogResult.OK)
            //{
            //    modelExView1.LoadTexture(OpenDlg.FileName, fileView1.SelectedItems[0].Index);
            //    fileView1.Files = modelExView1.TextureNames;
            //}
            //modelExView1.PauseRendering = false;
        }

        #endregion

        #region File Menu

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.PauseRendering = true;
            OpenFileDialog OpenDlg = new OpenFileDialog();
            OpenDlg.CheckFileExists = true;
            OpenDlg.CheckPathExists = true;
            OpenDlg.Filter =    "Soul Reaver Mesh Files|*.SRObj;*.drm;*.pcm|" +
                                "Soul Reaver DRM Files (*.drm)|*.drm|" +
                                "Soul Reaver PCM Files (*.pcm)|*.pcm|" +
                                "DirectX Mesh Files (*.x)|*.x|" +
                                "All Mesh Files|*.SRObj;*.drm;*.pcm;*.x|" +
                                "All Files (*.*)|*.*";
            OpenDlg.DefaultExt = "x";
            OpenDlg.FilterIndex = 1;
            if (OpenDlg.ShowDialog() == DialogResult.OK)
            {
                Directory.SetCurrentDirectory(Path.GetDirectoryName(OpenDlg.FileName));

                modelExView1.LoadModel(OpenDlg.FileName);
                resetAllToolStripMenuItem_Click(sender, e);

                saveToolStripMenuItem.Enabled = true;
                loadTexturesToolStripMenuItem.Enabled = true;
                fromFileToolStripMenuItem.Enabled = modelExView1.TextureArchives != null;

                String[] strModelNames = modelExView1.ModelNames;
                modelToolStripMenuItem.DropDownItems.Clear();

                if (strModelNames != null)
                {
                    ToolStripMenuItem[] axModelNameToolStripMenuItems = new ToolStripMenuItem[strModelNames.Length];
                    for (int m = 0; m < strModelNames.Length; m++)
                    {
                        axModelNameToolStripMenuItems[m] = new ToolStripMenuItem();
                        axModelNameToolStripMenuItems[m].Text = strModelNames[m];
                        axModelNameToolStripMenuItems[m].Name = strModelNames[m];
                        axModelNameToolStripMenuItems[m].Size = new System.Drawing.Size(154, 22);
                        axModelNameToolStripMenuItems[m].Click += new EventHandler(modelsToolStripMenuItem_Click);
                        if (modelExView1.ModelIndex == m)
                        {
                            axModelNameToolStripMenuItems[m].Checked = true;
                        }
                    }
                    modelToolStripMenuItem.DropDownItems.AddRange(axModelNameToolStripMenuItems);
                    modelToolStripMenuItem.Visible = (strModelNames.Length > 0);
                }

                fileView1.Files = modelExView1.TextureNames;

                switch (modelExView1.ControlMode)
                {
                    case ModelExView.ControlType.OrbitCamera:
                        orbitCamToolStripMenuItem.Checked = true;
                        flyCamToolStripMenuItem.Checked = false;
                        mapCamToolStripMenuItem.Checked = false;
                        rotateObjectToolStripMenuItem.Checked = false;
                        break;
                    case ModelExView.ControlType.FlyCamera:
                        orbitCamToolStripMenuItem.Checked = false;
                        flyCamToolStripMenuItem.Checked = true;
                        mapCamToolStripMenuItem.Checked = false;
                        rotateObjectToolStripMenuItem.Checked = false;
                        break;
                    case ModelExView.ControlType.MapCamera:
                        orbitCamToolStripMenuItem.Checked = false;
                        flyCamToolStripMenuItem.Checked = false;
                        mapCamToolStripMenuItem.Checked = true;
                        rotateObjectToolStripMenuItem.Checked = false;
                        break;
                    default:
                        orbitCamToolStripMenuItem.Checked = false;
                        flyCamToolStripMenuItem.Checked = false;
                        mapCamToolStripMenuItem.Checked = false;
                        rotateObjectToolStripMenuItem.Checked = true;
                        break;
                }
            }
            modelExView1.PauseRendering = false;
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (modelExView1.Object == null)
            {
                return;
            }

            modelExView1.PauseRendering = true;

            ModelExFileList xFileSaveList = new ModelExFileList();

            xFileSaveList.FolderName = Directory.GetCurrentDirectory();

            foreach (ModelExModel xModel in modelExView1.Object.Models)
            {
                xFileSaveList.Add(xModel.FileName, xModel);
            }

            foreach (ModelExEffect xEffect in modelExView1.Object.Effects)
            {
                xFileSaveList.Add(xEffect.Name, xEffect);
            }

            foreach (ModelExTexture xTexture in modelExView1.Object.Textures)
            {
                xFileSaveList.Add(xTexture.Name, xTexture);
            }

            if (xFileSaveList.ShowDialog() == DialogResult.OK)
            {
                modelExView1.Object.PrepareFilesForSave(xFileSaveList.UseEffects);

                foreach (ModelExFileList.Entry xEntry in xFileSaveList.Entries)
                {
                    if (xEntry.Save && xEntry.Enabled)
                    {
                        String strFileName = Path.Combine(xFileSaveList.FolderName, xEntry.FileName);
                        Type xObjectType = xEntry.Object.GetType();
                        if (typeof(ModelExModel).IsInstanceOfType(xEntry.Object))
                        {
                            ModelExModel xModel = (ModelExModel)xEntry.Object;
                            xModel.Save(strFileName, xFileSaveList.ModelFormat);
                            continue;
                        }
                        if (typeof(ModelExEffect).IsInstanceOfType(xEntry.Object))
                        {
                            ModelExEffect xEffect = (ModelExEffect)xEntry.Object;
                            xEffect.Save(strFileName);
                            continue;
                        }
                        if (typeof(ModelExTexture).IsInstanceOfType(xEntry.Object))
                        {
                            ModelExTexture xTexture = (ModelExTexture)xEntry.Object;
                            xTexture.Save(strFileName, xFileSaveList.ImageFormat);
                            continue;
                        }
                    }
                }

                modelExView1.Object.CleanupFilesAfterSave(true);
            }

            modelExView1.PauseRendering = false;
        }

        private void fromFolderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.PauseRendering = true;
            FolderBrowserDialog xFolderDlg = new FolderBrowserDialog();
            xFolderDlg.Description = "Load all required textures from the current folder";
            xFolderDlg.ShowNewFolderButton = false;
            xFolderDlg.SelectedPath = Directory.GetCurrentDirectory();
            if (xFolderDlg.ShowDialog() == DialogResult.OK)
            {
                modelExView1.LoadTexturesFromFolder(xFolderDlg.SelectedPath);
            }
            modelExView1.PauseRendering = false;
        }

        private void fromFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.PauseRendering = true;
            OpenFileDialog OpenDlg = new OpenFileDialog();
            OpenDlg.CheckFileExists = true;
            OpenDlg.CheckPathExists = true;
            OpenDlg.Filter = modelExView1.TextureArchives;
            OpenDlg.DefaultExt = modelExView1.TextureArchiveExt;
            OpenDlg.FilterIndex = 1;
            OpenDlg.FileName = Path.ChangeExtension(modelExView1.FileName, OpenDlg.DefaultExt);
            if (OpenDlg.ShowDialog() == DialogResult.OK)
            {
                modelExView1.LoadTexturesFromFile(OpenDlg.FileName);
                fileView1.Files = modelExView1.TextureNames;
            }
            modelExView1.PauseRendering = false;
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        #endregion

        #region View Modes

        private void lightingShadingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.Lighting = ((ToolStripMenuItem)sender).Checked;
        }

        private void showTexturesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.Textures = ((ToolStripMenuItem)sender).Checked;
        }

        private void textureFilteringToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.TextureFiltering = ((ToolStripMenuItem)sender).Checked;
        }

        private void wireframeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.Wireframe = ((ToolStripMenuItem)sender).Checked;
        }

        private void scalingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.Scaling = ((ToolStripMenuItem)sender).Checked;
        }

        private void modelsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int m = 0; m < modelToolStripMenuItem.DropDownItems.Count; m++)
            {
                ToolStripItem xMenuItem = modelToolStripMenuItem.DropDownItems[m];

                if (xMenuItem == sender)
                {
                    ((ToolStripMenuItem)xMenuItem).Checked = true;
                    modelExView1.ModelIndex = m;
                }
                else
                {
                    ((ToolStripMenuItem)xMenuItem).Checked = false;
                }
            }
        }

        #region Cull Mode

        private void clockwiseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            clockwiseToolStripMenuItem.Checked      = true;
            antiClockwiseToolStripMenuItem.Checked  = false;
            noneToolStripMenuItem.Checked           = false;
            modelExView1.CullMode                   = CullType.Clockwise;
        }

        private void antiClockwiseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            clockwiseToolStripMenuItem.Checked      = false;
            antiClockwiseToolStripMenuItem.Checked  = true;
            noneToolStripMenuItem.Checked           = false;
            modelExView1.CullMode                   = CullType.CounterClockwise;
        }

        private void noneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            clockwiseToolStripMenuItem.Checked      = false;
            antiClockwiseToolStripMenuItem.Checked  = false;
            noneToolStripMenuItem.Checked           = true;
            modelExView1.CullMode                   = CullType.None;
        }

        #endregion

        #endregion

        #region Reset Modes

        private void resetCameraPositionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.ResetCameraPosition();
        }

        private void resetObjectPositionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.ResetObjectPosition();
        }

        private void resetAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            modelExView1.ResetCameraPosition();
            modelExView1.ResetObjectPosition();
            modelExView1.ResetRenderStates();
            lightingShadingToolStripMenuItem.Checked = modelExView1.Lighting;
            showTexturesToolStripMenuItem.Checked = modelExView1.Textures;
            textureFilteringToolStripMenuItem.Checked = modelExView1.TextureFiltering;
            wireframeToolStripMenuItem.Checked = modelExView1.Wireframe;
            scalingToolStripMenuItem.Checked = modelExView1.Scaling;
            clockwiseToolStripMenuItem.Checked =
                (modelExView1.CullMode == CullType.Clockwise);
            antiClockwiseToolStripMenuItem.Checked =
                (modelExView1.CullMode == CullType.CounterClockwise);
            noneToolStripMenuItem.Checked =
                (modelExView1.CullMode == CullType.None);
        }

        #endregion

        #region Display Modes

        private void debugInfoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            debugInfoToolStripMenuItem.Checked = true;
            textBox1.Visible = debugInfoToolStripMenuItem.Checked;
            textureFilesToolStripMenuItem.Checked = false;
            fileView1.Visible = textureFilesToolStripMenuItem.Checked;
        }

        private void textureFilesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            debugInfoToolStripMenuItem.Checked = false;
            textBox1.Visible = debugInfoToolStripMenuItem.Checked;
            textureFilesToolStripMenuItem.Checked = true;
            fileView1.Visible = textureFilesToolStripMenuItem.Checked;
        }

        private void hideToolStripMenuItem_Click(object sender, EventArgs e)
        {
            hideToolStripMenuItem.Checked ^= true;
            splitContainer1.Panel2Collapsed ^= true;
        }

        #endregion

        #region Control Modes

        private void rotateObjectToolStripMenuItem_Click(object sender, EventArgs e)
        {
            orbitCamToolStripMenuItem.Checked = false;
            flyCamToolStripMenuItem.Checked = false;
            mapCamToolStripMenuItem.Checked = false;
            rotateObjectToolStripMenuItem.Checked = true;
            modelExView1.ControlMode = ModelExView.ControlType.RotateObject;
        }

        private void orbitCamToolStripMenuItem_Click(object sender, EventArgs e)
        {
            orbitCamToolStripMenuItem.Checked = true;
            flyCamToolStripMenuItem.Checked = false;
            mapCamToolStripMenuItem.Checked = false;
            rotateObjectToolStripMenuItem.Checked = false;
            modelExView1.ControlMode = ModelExView.ControlType.OrbitCamera;
        }

        private void flyCamToolStripMenuItem_Click(object sender, EventArgs e)
        {
            orbitCamToolStripMenuItem.Checked = false;
            flyCamToolStripMenuItem.Checked = true;
            mapCamToolStripMenuItem.Checked = false;
            rotateObjectToolStripMenuItem.Checked = false;
            modelExView1.ControlMode = ModelExView.ControlType.FlyCamera;
        }

        private void mapCamToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mapCamToolStripMenuItem.Checked = true;
            flyCamToolStripMenuItem.Checked = false;
            orbitCamToolStripMenuItem.Checked = false;
            rotateObjectToolStripMenuItem.Checked = false;
            modelExView1.ControlMode = ModelExView.ControlType.MapCamera;
        }

        #endregion
    }
}