using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace ModelEx3
{
    partial class ModelExFileList : AMF.FileSaveList
    {
        private ComboBox comboBox2;
        private ComboBox comboBox3;
        private Label label2;
        private Label label3;
        private CheckBox checkBox1;

        public ModelFormat ModelFormat
        {
            get
            {
                switch (comboBox2.SelectedIndex)
                {
                    case 0:
                        return ModelFormat.Text;
                    case 1:
                        return ModelFormat.TextCompressed;
                    case 2:
                        return ModelFormat.Binary;
                    default:
                        return ModelFormat.BinaryCompressed;
                }
            }
        }
        public ImageFormat ImageFormat { get { return (ImageFormat)comboBox3.SelectedIndex; } }
        public bool UseEffects { get { return checkBox1.Checked; } }
        
        public ModelExFileList()
        {
            InitializeComponent();

            comboBox2.SelectedIndex = 3;
            comboBox3.SelectedIndex = 2;
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.comboBox2 = new System.Windows.Forms.ComboBox();
            this.comboBox3 = new System.Windows.Forms.ComboBox();
            this.checkBox1 = new System.Windows.Forms.CheckBox();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // okButton
            // 
            this.okButton.Location = new System.Drawing.Point(15, 356);
            // 
            // cancelButton
            // 
            this.cancelButton.Location = new System.Drawing.Point(96, 356);
            // 
            // comboBox2
            // 
            this.comboBox2.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox2.FormattingEnabled = true;
            this.comboBox2.Items.AddRange(new object[] {
            "DirectX Mesh Files (Text)(*.x)",
            "DirectX Mesh Files (Compressed Text)(*.x)",
            "DirectX Mesh Files (Binary)(*.x)",
            "DirectX Mesh Files (Compressed Binary)(*.x)"});
            this.comboBox2.Location = new System.Drawing.Point(96, 301);
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(343, 21);
            this.comboBox2.TabIndex = 7;
            // 
            // comboBox3
            // 
            this.comboBox3.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox3.FormattingEnabled = true;
            this.comboBox3.Items.AddRange(new object[] {
            "Bitmap (*.bmp)",
            "JPEG (*.JPG)",
            "PNG (*.PNG)"});
            this.comboBox3.Location = new System.Drawing.Point(96, 328);
            this.comboBox3.Name = "comboBox3";
            this.comboBox3.Size = new System.Drawing.Size(343, 21);
            this.comboBox3.TabIndex = 8;
            // 
            // checkBox1
            // 
            this.checkBox1.AutoSize = true;
            this.checkBox1.Checked = true;
            this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
            this.checkBox1.Location = new System.Drawing.Point(358, 360);
            this.checkBox1.Name = "checkBox1";
            this.checkBox1.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
            this.checkBox1.Size = new System.Drawing.Size(81, 17);
            this.checkBox1.TabIndex = 10;
            this.checkBox1.Text = "Use Effects";
            this.checkBox1.UseVisualStyleBackColor = true;
            this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(13, 301);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(62, 13);
            this.label2.TabIndex = 11;
            this.label2.Text = "Model type:";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(13, 328);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(69, 13);
            this.label3.TabIndex = 12;
            this.label3.Text = "Texture type:";
            // 
            // ModelExFileList
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.ClientSize = new System.Drawing.Size(451, 385);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.comboBox2);
            this.Controls.Add(this.comboBox3);
            this.Controls.Add(this.checkBox1);
            this.Name = "ModelExFileList";
            this.Controls.SetChildIndex(this.listView1, 0);
            this.Controls.SetChildIndex(this.okButton, 0);
            this.Controls.SetChildIndex(this.checkBox1, 0);
            this.Controls.SetChildIndex(this.cancelButton, 0);
            this.Controls.SetChildIndex(this.comboBox3, 0);
            this.Controls.SetChildIndex(this.comboBox2, 0);
            this.Controls.SetChildIndex(this.label2, 0);
            this.Controls.SetChildIndex(this.label3, 0);
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion

        protected override bool ValidateObject(Object xObject)
        {
            if (typeof(ModelExModelInstance).IsInstanceOfType(xObject))
            {
                ModelExModelInstance xModel = (ModelExModelInstance)xObject;
                if (xModel.File == null)
                {
                    return false;
                }
            }
            if (typeof(ModelExEffectInstance).IsInstanceOfType(xObject))
            {
                ModelExEffectInstance xEffect = (ModelExEffectInstance)xObject;
                if (xEffect.File == null)
                {
                    return false;
                }
            }
            if (typeof(ModelExTextureInstance).IsInstanceOfType(xObject))
            {
                ModelExTextureInstance xTexture = (ModelExTextureInstance)xObject;
                if (xTexture.File == null)
                {
                    return false;
                }
            }

            return base.ValidateObject(xObject);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            foreach (Entry xEntry in Entries)
            {
                if (checkBox1.Checked || !xEntry.FileName.EndsWith(".fx"))
                {
                    xEntry.Enabled = true;
                }
                else
                {
                    xEntry.Enabled = false;
                }
            }
        }
    }
}
